;; Peg Solitaire domain

(define (domain pegsolitaire-temporal)
    (:requirements :typing :durative-actions :duration-inequalities)
    (:types location - object)
    (:predicates
        (IN-LINE ?x ?y ?z - location)
        (occupied ?l - location)
        (free ?l - location)
    )

    (:uncontrollable-durative-action jump
     :parameters (?from - location ?during - location ?to - location)
     :duration (and (>= ?duration 1) (<= ?duration 3))
     :condition (and
                    (over all (IN-LINE ?from ?during ?to))
                    (at start (occupied ?from))
                    (at start (occupied ?during))
                    (at start (free ?to))
                )
     :effect (and
                 (at start (not (occupied ?from)))
                 (at start (not (occupied ?during)))
                 (at start (not (free ?to)))
                 (at end (free ?from))
                 (at end (free ?during))
                 (at end (occupied ?to))
             )
    )
)
